modules/product/controllers/ProductController.php
<?php

namespace app\modules\product\controllers;

use app\controllers\BaseController;
use app\services\Bug;
use app\services\Demand;
use app\services\File;
use app\services\Product;
use app\utils\Utils;
use Yii;
use yii\helpers\ArrayHelper;
use yii\helpers\Url;


class ProductController extends BaseController
{
    public function actionIndex()
    {
        $product_info = Product::productStatistics();
        return $this->render('index', ['product_info' => $product_info]);
    }

    public function actionList()
    {
        $request = Yii::$app->request;

        $where[] = ['status' => [10, 20]];

        //只获取拥有产品组成员的产品
        $where[] = ['id' => Product::authProductId([10, 20])];

        if ($search = Utils::formUnserialize($request->post('searchData'))) {
            foreach ($search as $k => $v) {
                if ($v === '') {
                    continue;
                }
                switch ($k) {
                    case 'order_no':
                        $where[] = ['id' => Utils::getNumeric($v, 'PROD')];
                        break;
                    case 'title':
                        $where[] = ['like', $k, $v];
                        break;
                    case 'status':
                        $where[] = [$k => $v];
                        break;
                }
            }
        }

        $result = Product::listPage($where, '*', 'id DESC', $request->post('page', 1), $request->post('limit', 10));
        $return = ArrayHelper::toArray($result);

        foreach ($result['data'] as $key => $val) {
            $return['data'][$key]['order_no'] = Utils::generateOrderNo('PROD', $val->id);
            $return['data'][$key]['start_date'] = $val->start_date ? date('Y-m-d', $val->start_date) : '待完善';
            $return['data'][$key]['acceptance_date'] = $val->acceptance_date ? date('Y-m-d', $val->acceptance_date) : '待完善';
            $return['data'][$key]['expire_date'] = $val->expire_date ? date('Y-m-d', $val->expire_date) : '待完善';
            $return['data'][$key]['duration_left'] = $val->duration_total - $val->duration_used;
            $return['data'][$key]['status'] = $val::getStatus()[$val->status];
            $return['data'][$key]['status'] = $val::getStatus()[$val->status];
            $return['data'][$key]['demand_total'] = Demand::find()->where(['product_id' => $val->id, 'status' => 10, 'step' => [0, 1, 2]])->count();
            $return['data'][$key]['bug_total'] = Bug::find()->where(['product_id' => $val->id, 'status' => 10, 'step' => [0, 1, 2]])->count();;
        }
        return $this->asJson($return);
    }

    public function actionCreate()
    {
        $request = Yii::$app->request;
        $post = $request->post();

        if ($request->isPost) {
            $model = new Product();
            $model->load($post, '');
            $model->start_date = $post['start_date'] ? strtotime($post['start_date']) : 0;
            $model->acceptance_date = $post['acceptance_date'] ? strtotime($post['acceptance_date']) : 0;
            $model->expire_date = $post['expire_date'] ? strtotime($post['expire_date']) : 0;
            if ($model->save()) {
                if (isset($post['attachment'])) File::batchSave($post['attachment'], 'product', $model->id);
                $model->operation_log->create($this, "创建了产品 {$model->title}", Url::to(['view', 'id' => $model->id]), true);
                return $this->success([], '创建成功');
            }
            return $this->error($model->errors);
        }

        return $this->render('create');
    }

    public function actionUpdate($id)
    {
        $request = Yii::$app->request;
        $post = $request->post();

        if ($request->isPost) {
            $model = Product::findOne(['id' => $post['id'], 'status' => [10, 20]]);
            $model->load($post, '');
            $model->start_date = $post['start_date'] ? strtotime($post['start_date']) : 0;
            $model->acceptance_date = $post['acceptance_date'] ? strtotime($post['acceptance_date']) : 0;
            $model->expire_date = $post['expire_date'] ? strtotime($post['expire_date']) : 0;
            if ($model->save()) {
                if (isset($post['attachment'])) File::batchSave($post['attachment'], 'product', $model->id);
                if (isset($post['attachment_remove'])) File::batchRemove($post['attachment_remove']);
                $model->operation_log->create($this, "编辑了产品 {$model->title}", Url::to(['view', 'id' => $model->id]), true);
                return $this->success([], '编辑成功');
            }
            return $this->error($model->errors);
        }

        if (!$model = Product::findOne(['id' => $id, 'status' => [10, 20]])) {
            return $this->alert('未找到该产品');
        }

        return $this->render('update', ['model' => $model]);
    }

    public function actionView($id)
    {
        if (!$model = Product::findOne(['id' => $id, 'status' => [10, 20]])) {
            return $this->alert('未找到该产品');
        }

        return $this->render('view', ['model' => $model]);
    }

    public function actionDelete($id)
    {
        if (!$model = Product::findOne(['id' => $id, 'status' => [10, 20]])) {
            return $this->error('未找到该产品');
        }
        $model->status = 0;
        $model->save();
        $model->operation_log->create($this, "删除了产品 {$model->title}",'',true);
        return $this->success([], '删除成功');
    }
}

modules/product/controllers/ProductUserController.php
<?php

namespace app\modules\product\controllers;

use app\controllers\BaseController;
use app\services\Product;
use app\services\ProductUser;
use app\services\User;
use app\utils\Utils;
use Yii;
use yii\helpers\ArrayHelper;
use yii\helpers\Url;


class ProductUserController extends BaseController
{
    public function actionList()
    {
        $request = Yii::$app->request;

        $where[] = ['product_user.product_id' => $request->get('product_id')];
        $where[] = ['product_user.status' => 10];

        if ($search = Utils::formUnserialize($request->post('searchData'))) {
            foreach ($search as $k => $v) {
                if ($v === '') {
                    continue;
                }
                switch ($k) {
                    case 'order_no':
                        $where[] = ['user.id' => Utils::getNumeric($v, 'USER')];
                        break;
                    case 'realname':
                        $where[] = ['like', 'user.realname', $v];
                        break;
                    case 'username':
                        $where[] = ['user.username' => $v];
                        break;
                }
            }
        }

        $result = ProductUser::listPage($where, 'product_user.*', 'product_user.id DESC', $request->post('page', 1), $request->post('limit', 10), ['user']);
        $return = ArrayHelper::toArray($result);

        foreach ($result['data'] as $key => $val) {
            $user = ArrayHelper::toArray($val->user);
            $return['data'][$key] = $user;
            $return['data'][$key]['id'] = $val->id;
            $return['data'][$key]['user_id'] = $user['id'];
            $return['data'][$key]['order_no'] = Utils::generateOrderNo('USER', $user['id']);
            $return['data'][$key]['status'] = User::getStatus()[$user['status']];
            $return['data'][$key]['created_at'] = date('Y-m-d H:i:s', $user['created_at']);

        }
        return $this->asJson($return);
    }


    public function actionCreate()
    {
        $request = Yii::$app->request;
        $post = $request->post();

        $product_id = $post['product_id'];
        $checked = $post['checked'];

        if (!$product = Product::findOne(['id' => $product_id, 'status' => 10])) {
            return $this->error('未找到该产品');
        }

        foreach ($checked as $key => $val) {
            $p_user = ProductUser::findOne(['product_id' => $product_id, 'user_id' => $val['id']]) ?: new ProductUser();
            $p_user->product_id = $product_id;
            $p_user->user_id = $val['id'];
            $p_user->status = 10;
            $p_user->save();
            $p_user->operation_log->create($this, "添加了产品 {$product->title} 项目成员 {$p_user->user->name}", Url::to(['/product/product/view', 'id' => $p_user->product_id]),true);
        }

        return $this->success([], '新增产品成员成功');
    }

    public function actionDelete($id)
    {
        if (!$model = ProductUser::findOne(['id' => $id, 'status' => 10])) {
            return $this->error('未找到该成员');
        }
        $model->status = 0;
        $model->save();
        $model->operation_log->create($this, "移除了产品 {$model->product->title} 项目成员 {$model->user->name}", Url::to(['/product/product/view', 'id' => $model->product_id]),true);
        return $this->success([], '移除成功');
    }
}

modules/product/views/product/create.php
<?php

?>

<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-card">
        <div class="layui-card-header">
            <b>创建产品</b>
        </div>
        <div class="layui-card-body">
            <form class="layui-form" action="" method="post">
                <div class="layui-form-item">
                    <label class="layui-form-label must">产品名称</label>
                    <div class="layui-input-block">
                        <input type="text" name="title" lay-verify="required" placeholder="请输入产品名称"
                               autocomplete="off" class="layui-input">
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">产品描述</label>
                    <div class="layui-input-block">
                        <textarea id="remark" name="remark" class="layui-textarea"></textarea>
                    </div>
                </div>

                <div class="layui-row">
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label must">总计工期</label>
                            <div class="layui-input-block">
                                <input type="number" name="duration_total" lay-verify="required" placeholder="请输入产品总计工期"
                                       class="layui-input">
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label must">已用工期</label>
                            <div class="layui-input-block">
                                <input type="number" name="duration_used" lay-verify="required" placeholder="请输入产品已用工期"
                                       class="layui-input">
                            </div>
                        </div>
                    </div>
                </div>

                <div class="layui-row">
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">发起时间</label>
                            <div class="layui-input-block">
                                <input type="text" name="start_date" placeholder="请选择产品发起时间"
                                       class="layui-input auto-date" readonly>
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">验收时间</label>
                            <div class="layui-input-block">
                                <input type="text" name="acceptance_date" placeholder="请选择产品验收时间"
                                       class="layui-input auto-date" readonly>
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">合同到期时间</label>
                            <div class="layui-input-block">
                                <input type="text" name="expire_date" placeholder="请选择合同到期时间"
                                       class="layui-input auto-date" readonly>
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">状态</label>
                            <div class="layui-input-block">
                                <select name="status" id="">
                                    <?php foreach (\app\services\Product::getStatus() as $key => $val): ?>
                                        <option value="<?= $key ?>"><?= $val ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">附件</label>
                    <div class="layui-input-block">
                        <a href="javascript:void(0)" class="layui-btn layui-btn-sm layui-btn-primary upload-file-btn"
                           data-name="attachment">
                            <i class="layui-icon layui-icon-addition"></i>添加文件
                        </a>
                    </div>
                </div>

                <div class="layui-form-item">
                    <div class="layui-input-block">
                        <button class="layui-btn layui-btn-normal layui-btn-sm ajax-submit" lay-submit
                                lay-filter="submit" after-success="close">立即提交
                        </button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

<?php $this->beginBlock('js') ?>

<?php $this->endBlock() ?>

modules/product/views/product/index.php
<?php

use yii\helpers\Url;

?>

<div class="layui-fluid layui-anim layui-anim-fadein layui-col-md-offset1 layui-col-md10">
    <div class="layui-row layui-col-space10">
        <!--左边栏-->
        <div class="layui-col-sm8">
            <!--产品统计-->
            <?= $this->render('plug/prod_statistics', ['product_info' => $product_info]) ?>

            <!--产品列表-->
            <?= $this->render('plug/prod_list') ?>
        </div>

        <!--右边栏-->
        <div class="layui-col-sm4">
            <!--我的需求-->
            <?= \app\components\MyDemandWidget::widget() ?>

            <!--我的Bug-->
            <?= \app\components\MyBugWidget::widget() ?>
        </div>
    </div>
</div>

<?php $this->beginBlock('js') ?>
<script>
    layui.table.render({
        where: {},
        elem: '#dataTable',
        url: "<?= Url::to(['list']) ?>", //数据接口
        method: "post",
        page: true,
        height: 350,
        limit: 20,
        toolbar: '#search-toolbar',
        defaultToolbar: [],
        smartReloadModel: true,
        cols: [[
            {
                fixed: 'handle',
                width: 130,
                title: "操作",
                align: 'center',
                toolbar: '#dataTableHandle'
            },
            {field: 'order_no', width: 120, title: "产品编号"},
            {field: 'title', width: 120, title: "产品名称"},
            {field: 'demand_total', width: 90, title: "进行需求数"},
            {field: 'bug_total', width: 90, title: "进行Bug数"},
            {field: 'duration_total', width: 80, title: "总计工期"},
            {field: 'duration_used', width: 80, title: "已用工期"},
            {field: 'duration_left', width: 80, title: "剩余工期"},
            {field: 'start_date', width: 100, title: "开始时间"},
            {field: 'acceptance_date', width: 100, title: "验收时间"},
            {field: 'expire_date', width: 110, title: "合同到期时间"},
            {field: 'status', width: 50, title: "状态"},
        ]]
    });

    $('.produce-list li').mouseover(function () {
        $(this).siblings().removeClass('li_this');
        $(this).addClass('li_this');
        $('#product_detail').find('.product-detail-view').hide();
        $('#product_detail').find('#' + $(this).attr('for')).show();
    })

    function chooseUserCall(checked, get_params) {
        var data = {"product_id": get_params.product_id, "checked": checked};
        $.ajax({
            type: "POST",
            data: data,
            url: "<?= Url::to(['product-user/create'])?>",
            success: function (res) {
                if (res.error == 0) {
                    layui.layer.close(layui.layer.index)
                }

                layui.layer.msg(res.msg);
            }
        });
    }
</script>
<?php $this->endBlock() ?>

modules/product/views/product/view.php
<?php

use yii\helpers\Url;

?>

<style>
    .upload-file-remove-btn {
        display: none
    }
</style>

<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-card">
        <div class="layui-card-header">
            <b>产品详情</b>
        </div>
        <div class="layui-card-body">
            <form class="layui-form" action="" method="post">
                <div class="layui-form-item">
                    <label class="layui-form-label">产品名称</label>
                    <div class="layui-input-block">
                        <input type="text" name="title" lay-verify="required" placeholder="请输入产品名称"
                               autocomplete="off" class="layui-input" value="<?= $model->title ?>" disabled>
                    </div>
                </div>

                <div class="layui-form-item">
                    <label class="layui-form-label">产品描述</label>
                    <div class="layui-input-block">
                        <textarea id="remark" name="remark" class="layui-textarea"
                                  disabled><?= $model->remark ?></textarea>
                    </div>
                </div>

                <div class="layui-row">
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">总计工期</label>
                            <div class="layui-input-block">
                                <input type="number" name="duration_total" lay-verify="required" placeholder="请输入产品总计工期"
                                       class="layui-input" value="<?= $model->duration_total ?>" disabled>
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">已用工期</label>
                            <div class="layui-input-block">
                                <input type="number" name="duration_used" lay-verify="required" placeholder="请输入产品已用工期"
                                       class="layui-input" value="<?= $model->duration_used ?>" disabled>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="layui-row">
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">发起时间</label>
                            <div class="layui-input-block">
                                <input type="text" name="start_date" lay-verify="required" placeholder="请选择产品发起时间"
                                       class="layui-input auto-date" readonly disabled
                                       value="<?= $model->start_date ? date('Y-m-d', $model->start_date) : '' ?>">
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">验收时间</label>
                            <div class="layui-input-block">
                                <input type="text" name="acceptance_date" placeholder="请选择产品验收时间"
                                       class="layui-input auto-date" readonly disabled
                                       value="<?= $model->acceptance_date ? date('Y-m-d', $model->acceptance_date) : '' ?>">
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">合同到期时间</label>
                            <div class="layui-input-block">
                                <input type="text" name="expire_date" placeholder="请选择合同到期时间"
                                       class="layui-input auto-date" readonly disabled
                                       value="<?= $model->expire_date ? date('Y-m-d', $model->expire_date) : '' ?>">
                            </div>
                        </div>
                    </div>
                    <div class="layui-col-sm6">
                        <div class="layui-form-item">
                            <label class="layui-form-label">状态</label>
                            <div class="layui-input-block">
                                <select name="status" id="" disabled>
                                    <?php foreach (\app\services\Product::getStatus() as $key => $val): ?>
                                        <option value="<?= $key ?>" <?= $model->status === $key ? 'selected' : '' ?>><?= $val ?></option>
                                    <?php endforeach; ?>
                                </select>
                            </div>
                        </div>
                    </div>

                    <div class="layui-form-item">
                        <label class="layui-form-label">附件</label>
                        <div class="layui-input-block">
                            <a href="javascript:void(0)"
                               class="layui-btn layui-btn-sm layui-btn-primary upload-file-btn hidden"
                               data-name="attachment" data-id="<?= $model->id ?>" data-module="product">
                                <i class="layui-icon layui-icon-addition"></i>添加文件
                            </a>
                        </div>
                    </div>
                </div>
            </form>
        </div>
    </div>

    <div class="layui-card">
        <div class="layui-card-header">
            <b>产品成员</b>
        </div>
        <div class="layui-card-body">
            <table id="dataTable" lay-filter="dataTable"></table>
            <!--搜索栏-->
            <script type="text/html" id="search-toolbar">
                <form class="search-form layui-form" for-table-filter="dataTable">
                    <div class="layui-show-xs-block hidden">
                        <a href="javascript:void(0)"
                           class="layui-btn layui-btn-sm layui-btn-primary toolbar-search-show">搜索</a>
                    </div>

                    <div class="layui-hide-xs toolbar-search-area">
                        <div class="layui-inline">
                            <input type="text" name="order_no" placeholder="人员编号"
                                   class="layui-input">
                        </div>

                        <div class="layui-inline">
                            <input type="text" name="username" placeholder="用户名"
                                   class="layui-input">
                        </div>

                        <div class="layui-inline">
                            <input type="text" name="realname" placeholder="姓名"
                                   class="layui-input">
                        </div>

                        <div class="layui-inline">
                            <a href="javascript:;" class="layui-btn layui-btn-sm layui-btn-normal toolbar-search-btn">
                                <i class="layui-icon layui-icon-search"></i>搜索
                            </a>

                            <a href="javascript:;" class="layui-btn layui-btn-sm layui-btn-normal toolbar-search-reset">
                                <i class="layui-icon layui-icon-refresh-1"></i>重置搜索条件
                            </a>

                            <a class="layui-btn layui-btn-sm layui-btn-normal iframe-layer"
                               data-title="[<?= $model['title'] ?>]添加产品成员" data-reload="dataTable"
                               data-url="<?= \yii\helpers\Url::to(['/common/select/user-list', 'product_id' => $model['id'], 'select_type' => 'checkbox']) ?>">
                                <i class="layui-icon layui-icon-addition"></i> 添加成员</a>
                        </div>
                    </div>
                </form>
            </script>

            <!--操作栏-->
            <script type="text/html" id="dataTableHandle">
                <a class="layui-btn layui-btn-xs layui-btn-normal iframe-layer"
                   data-url="<?= Url::to(['/common/select/user-view']) ?>&id={{= d.user_id }}"
                   data-reload="dataTable" data-title="详情">详情</a>

                <a class="layui-btn layui-btn-xs layui-btn-danger confirm-layer"
                   data-url="<?= Url::to(['/product/product-user/delete']) ?>&id={{= d.id }}"
                   data-reload="dataTable">移除</a>
            </script>
        </div>
    </div>
</div>

<?php $this->beginBlock('js') ?>
<script>
    layui.table.render({
        where: {},
        elem: '#dataTable',
        url: "<?= Url::to(['product-user/list', 'product_id' => Yii::$app->request->get('id')]) ?>", //数据接口
        method: "post",
        page: true,
        height: "350",
        limit: 20,
        toolbar: '#search-toolbar',
        defaultToolbar: [],
        smartReloadModel: true,
        cols: [[
            {
                fixed: 'handle',
                width: 100,
                title: "操作",
                align: 'center',
                toolbar: '#dataTableHandle'
            },
            {field: 'order_no', width: 120, title: "人员编号"},
            {field: 'username', width: 120, title: "用户名"},
            {field: 'realname', width: 120, title: "姓名"},
            {field: 'mobile', width: 120, title: "手机号"},
            {field: 'qq', width: 100, title: "QQ号"},
            {field: 'wechat', width: 160, title: "微信号"},
            {field: 'address', width: 260, title: "住址"},
            {field: 'status', width: 50, title: "状态"},
            {field: 'created_at', width: 180, title: "创建时间"},
        ]]
    });

    function chooseUserCall(checked, get_params) {
        var data = {"product_id": get_params.product_id, "checked": checked};
        $.ajax({
            type: "POST",
            data: data,
            url: "<?= Url::to(['product-user/create'])?>",
            success: function (res) {
                if (res.error == 0) {
                    layui.layer.close(layui.layer.index)
                }

                layui.layer.msg(res.msg);
            }
        });
    }
</script>
<?php $this->endBlock() ?>